import { Node } from './node';
export interface ASTPreprocessorOptions {
    directory: string;
}
/**
 * Process AST before it's really parsed
 * by ASTParser so we can replace import declaration's
 * with it's AST file contents
 */
declare class ASTPreprocessor {
    ast: Node[];
    /**
     * Output with import statements replaced with AST content
     */
    private result;
    /**
     * Preprocessor options
     */
    private options;
    /**
     * Registered aliases
     */
    private aliases;
    constructor(ast: Node[], options: ASTPreprocessorOptions);
    getResult(): Node[];
    private process;
}
export default ASTPreprocessor;
