import Parser from './index';
import { Node } from './node';
/**
 * Scan parser context and look for container
 * matches based on expression path.
 *
 * -- Brief description --
 * An expression path is an array of strings determining a container reference,
 * either it points directly to a container type (matching various containers) or
 * it points directly to a single container.
 *
 * Context scanner will look into AST trying to find namespaces that matches the
 * given path.
 *
 * TODO: Improve searching algorithm and break it in many parts
 */
declare class ContextScanner {
    private parser;
    constructor(parser: Parser);
    match(expressionPath: string[]): string[][];
    _match(expressionPath: string[]): string[][];
    /**
     * Resolve a type inside a context
     * @param name Container name/container type to look for
     * @param body Body to look for
     * @param namespace Namespace to start from
     */
    resolveTypeInBody(name: string, body: Node[], namespace: string[]): Node[];
}
export default ContextScanner;
