import { Node, NodeContainerParam, NodeContainerGroup } from './node';
import ContextScanner from './context-scanner';
import TemplateProcessor from './template-processor';
import { Container, ContainerParam } from './constants';
import { Param } from './param';
export interface ASTParserOptions {
    path?: string[];
    parent?: ASTParser;
    directory: string;
    containers: Container[];
    namespaceSeparator?: string;
}
declare class ASTParser {
    static defineDefaultOptions(options: any): void;
    ast: Node[];
    path: string[];
    parent?: ASTParser;
    scanner: ContextScanner;
    options: ASTParserOptions;
    containers: Container[];
    namespaceSeparator: string;
    templateProcessors: Map<string, TemplateProcessor<any>>;
    constructor(ast: Node[], options: ASTParserOptions);
    parse(): void;
    parseParamType(paramType: Node): Param;
    processMemberExpression(paramType: Node): string[];
    parseContainerParam(param: NodeContainerParam): ContainerParam;
    createCrcString(ast: Node): string;
    processContainerGroupNode(ast: Node, parent: NodeContainerGroup): void;
    parseAstItem(ast: Node): void;
}
export default ASTParser;
