"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var template_processor_1 = (0, tslib_1.__importDefault)(require("./template-processor"));
var constants_1 = require("./constants");
var StrictSizeProcessor = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(StrictSizeProcessor, _super);
    function StrictSizeProcessor() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    StrictSizeProcessor.prototype.createCrcString = function (args) {
        var _this = this;
        return args.reduce(function (result, param) {
            var parsed = [];
            if (param.type == constants_1.Syntax.LiteralNumber)
                parsed.push(param.value.toString());
            else
                parsed = parsed.concat(_super.prototype.createCrcString.call(_this, [param]));
            return result.concat(parsed);
        }, new Array());
    };
    StrictSizeProcessor.prototype.process = function (args) {
        var _this = this;
        if (args.length != 2)
            throw new Error("Invalid length of arguments for StrictSize template");
        return args.map(function (arg) {
            if (arg.type == constants_1.Syntax.LiteralNumber)
                return arg;
            return _this.parser.parseParamType(arg);
        });
    };
    return StrictSizeProcessor;
}(template_processor_1["default"]));
exports["default"] = StrictSizeProcessor;
