"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var autobind_decorator_1 = (0, tslib_1.__importDefault)(require("autobind-decorator"));
var CodeStream = /** @class */ (function () {
    function CodeStream(generator) {
        this.generator = generator;
        this.code = '';
    }
    CodeStream.prototype.write = function (start, getContent, end) {
        if (typeof getContent !== 'function' || typeof end !== 'string' || typeof start !== 'string') {
            this.code += this.generator.indentCode(start);
            return;
        }
        this.code += this.generator.indentCode(start);
        this.generator.increaseDepth();
        getContent();
        this.generator.decreaseDepth();
        this.code += this.generator.indentCode(end);
    };
    CodeStream.prototype.prepend = function (value) {
        this.code = value + this.code;
    };
    CodeStream.prototype.append = function (value) {
        this.code += value;
    };
    /**
     * @returns Return the contents at `code` property and clears it
     */
    CodeStream.prototype.valueOf = function () {
        var value = this.code;
        this.code = '';
        return value;
    };
    CodeStream = (0, tslib_1.__decorate)([
        autobind_decorator_1["default"],
        (0, tslib_1.__metadata)("design:paramtypes", [Object])
    ], CodeStream);
    return CodeStream;
}());
exports["default"] = CodeStream;
