import { NodeContainerDeclaration, Node, Comment } from "../ast-parser/node";
import CodeGeneratorChild from "./code-generator-child";
import { ITypeCodecOptions } from "./type-code-generator";
/**
 * Responsible for generating container declaration code
 */
export default class ContainerDeclarationGenerator extends CodeGeneratorChild {
    generate(item: NodeContainerDeclaration): string;
    attachComments(comments: Comment[]): string;
    createCopyStatements(item: NodeContainerDeclaration): string;
    createContainerParamsInterface(item: NodeContainerDeclaration): void;
    createContainerInterfaceParams(item: NodeContainerDeclaration, transform?: (value: string) => string): string;
    getDecoratorFromParam(node: Node): string;
    createDecodingStatements(node: Node): string;
    createEncodingStatements(item: NodeContainerDeclaration): string;
    createParamDecodingStatement(node: Node, options: ITypeCodecOptions): string;
    createToplevelDecodeMethod(node: Node): string;
    createParamEncodingStatement(node: Node, options: ITypeCodecOptions): string;
    private writeContainerClassComments;
}
