"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var container_declaration_generator_1 = (0, tslib_1.__importDefault)(require("./container-declaration-generator"));
var ContainerDeclarationInterfaceGenerator = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(ContainerDeclarationInterfaceGenerator, _super);
    function ContainerDeclarationInterfaceGenerator(parent, options) {
        var _this = _super.call(this, parent) || this;
        _this.options = (0, tslib_1.__assign)({ readonly: true }, options);
        return _this;
    }
    ContainerDeclarationInterfaceGenerator.prototype.generate = function (node) {
        var _this = this;
        var _a = this.cs, write = _a.write, append = _a.append, valueOf = _a.valueOf;
        this.setCurrentNode(node);
        if (node.leadingComments.length) {
            this.attachComments(node.leadingComments);
        }
        var container = this.getContainer(node.name);
        var paramPrefix = this.getInterfaceParamPrefix();
        write("export interface ".concat(this.getClassNameFromList(node), " {\n"), function () {
            write("".concat(paramPrefix, "_id?: 0x").concat(container.id.toString(16), ";\n"));
            write("".concat(paramPrefix, "_type?: \"").concat(container.type, "\";\n"));
            write("".concat(paramPrefix, "_name: \"").concat(container.name, "\";\n"));
            append(_this.createContainerInterfaceParams(node, function (param) { return "".concat(paramPrefix).concat(param); }));
        }, '}\n');
        this.setCurrentNode(undefined);
        return valueOf();
    };
    ContainerDeclarationInterfaceGenerator.prototype.getInterfaceParamPrefix = function () {
        var text = '';
        var readonly = this.options.readonly;
        if (readonly) {
            text += 'readonly';
        }
        if (text.length > 0) {
            text += ' ';
        }
        return text;
    };
    return ContainerDeclarationInterfaceGenerator;
}(container_declaration_generator_1["default"]));
exports["default"] = ContainerDeclarationInterfaceGenerator;
