"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var code_generator_child_1 = (0, tslib_1.__importDefault)(require("./code-generator-child"));
var constants_1 = require("../ast-parser/constants");
var ContainerGroupGenerator = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(ContainerGroupGenerator, _super);
    function ContainerGroupGenerator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ContainerGroupGenerator.prototype.generate = function (item) {
        var e_1, _a;
        this.setParentNode(item);
        this.setCurrentNode(item);
        var _b = this.cs, write = _b.write, append = _b.append, valueOf = _b.valueOf;
        var interfaceName = "T".concat(this.getInterfaceName(item.name));
        var containerDeclGenerator = this.getGenerator('containerDeclaration');
        write("export abstract class ".concat(interfaceName, " extends DataContainer {\n"), function () {
            var e_2, _a;
            var stubs = new Array({
                stubMethod: 'encode',
                args: ['serializer: Serializer', 'ignoreHeader?: boolean'],
                returnType: 'void'
            });
            try {
                for (var stubs_1 = (0, tslib_1.__values)(stubs), stubs_1_1 = stubs_1.next(); !stubs_1_1.done; stubs_1_1 = stubs_1.next()) {
                    var _b = stubs_1_1.value, stubMethod = _b.stubMethod, args = _b.args, returnType = _b.returnType;
                    write("public abstract ".concat(stubMethod, "(").concat(args.join(', '), "): ").concat(returnType, ";\n"));
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (stubs_1_1 && !stubs_1_1.done && (_a = stubs_1["return"])) _a.call(stubs_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
            append(containerDeclGenerator.createToplevelDecodeMethod(item));
        }, '}\n');
        try {
            for (var _c = (0, tslib_1.__values)(item.body), _d = _c.next(); !_d.done; _d = _c.next()) {
                var node = _d.value;
                if (node.type === constants_1.Syntax.ContainerDeclaration) {
                    append(containerDeclGenerator.generate(node));
                    continue;
                }
                append(this.processNode(node));
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c["return"])) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
        this.setParentNode(undefined);
        this.setCurrentNode(undefined);
        return valueOf();
    };
    return ContainerGroupGenerator;
}(code_generator_child_1["default"]));
exports["default"] = ContainerGroupGenerator;
