"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var code_generator_child_1 = (0, tslib_1.__importDefault)(require("./code-generator-child"));
var constants_1 = require("../ast-parser/constants");
var ContainerGroupInterfaceGenerator = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(ContainerGroupInterfaceGenerator, _super);
    function ContainerGroupInterfaceGenerator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ContainerGroupInterfaceGenerator.prototype.generate = function (node) {
        var e_1, _a;
        var _b = this.cs, write = _b.write, append = _b.append, valueOf = _b.valueOf;
        this.setCurrentNode(node);
        write("export type ".concat(this.getClassNameFromList(node), " = ").concat(this.getContainerNames(node), ";\n"));
        try {
            for (var _c = (0, tslib_1.__values)(node.body), _d = _c.next(); !_d.done; _d = _c.next()) {
                var item = _d.value;
                append(this.getGenerator('containerDeclaration').generate(item));
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c["return"])) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
        this.setCurrentNode(undefined);
        return valueOf();
    };
    ContainerGroupInterfaceGenerator.prototype.getContainerNames = function (group) {
        var e_2, _a;
        var names = [];
        try {
            for (var _b = (0, tslib_1.__values)(group.body), _c = _b.next(); !_c.done; _c = _b.next()) {
                var node = _c.value;
                this.setCurrentNode(node);
                if (node.type === constants_1.Syntax.ContainerDeclaration) {
                    names.push(this.getClassNameFromList(node));
                }
                this.setCurrentNode(group);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b["return"])) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return names.join(' | ');
    };
    return ContainerGroupInterfaceGenerator;
}(code_generator_child_1["default"]));
exports["default"] = ContainerGroupInterfaceGenerator;
