"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var ModuleResolver = /** @class */ (function () {
    function ModuleResolver(moduleCache) {
        this.moduleCache = moduleCache;
        this.imports = new Map();
    }
    ModuleResolver.prototype.requireImport = function (name, inputOptions) {
        var e_1, _a, e_2, _b;
        var options;
        if (typeof inputOptions === 'string') {
            options = {
                "default": inputOptions,
                args: []
            };
        }
        else {
            options = inputOptions;
        }
        try {
            for (var _c = (0, tslib_1.__values)(options.args), _d = _c.next(); !_d.done; _d = _c.next()) {
                var arg = _d.value;
                if (!/^([a-zA-Z\-]+)$/.test(arg)) {
                    throw new Error("Invalid argument: ".concat(arg));
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c["return"])) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var foundImport = this.imports.get(name);
        if (foundImport) {
            try {
                for (var _e = (0, tslib_1.__values)(options.args), _f = _e.next(); !_f.done; _f = _e.next()) {
                    var arg = _f.value;
                    if (foundImport.args.indexOf(arg) === -1) {
                        foundImport.args.push(arg);
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_f && !_f.done && (_b = _e["return"])) _b.call(_e);
                }
                finally { if (e_2) throw e_2.error; }
            }
        }
        if (!foundImport) {
            this.imports.set(name, {
                name: this.resolve(name),
                "default": options["default"],
                args: options.args
            });
        }
    };
    ModuleResolver.prototype.resolve = function (moduleName) {
        var value = this.moduleCache.get(moduleName);
        if (!value) {
            return moduleName;
        }
        return value;
    };
    return ModuleResolver;
}());
exports["default"] = ModuleResolver;
