"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var constants_1 = require("../../ast-parser/constants");
var template_code_generator_1 = (0, tslib_1.__importDefault)(require("./template-code-generator"));
var OptionalCodeGenerator = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(OptionalCodeGenerator, _super);
    function OptionalCodeGenerator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    OptionalCodeGenerator.prototype.getDecodingCode = function (node, options) {
        var _a = this.cs, valueOf = _a.valueOf, append = _a.append, write = _a.write;
        var paramType = node.paramType;
        if (paramType.type !== constants_1.Syntax.Template) {
            throw new Error('Received invalid container param');
        }
        var containerDeclGenerator = this.getContainerDeclarationGenerator();
        write("if(deserializer.readUInt8() === 1) {\n", function () {
            append(containerDeclGenerator.createParamDecodingStatement((0, tslib_1.__assign)((0, tslib_1.__assign)({}, node), { type: constants_1.Syntax.ContainerParam, paramType: paramType.arguments[0] }), options));
        }, '}\n');
        return valueOf();
    };
    OptionalCodeGenerator.prototype.getEncodingCode = function (node, options) {
        var _this = this;
        var paramType = node.paramType;
        var _a = this.cs, write = _a.write, valueOf = _a.valueOf, append = _a.append;
        if (paramType.type !== constants_1.Syntax.Template) {
            throw new Error('Received invalid param type');
        }
        var constValue = this.getVariableName(node.name, 'optional ensured value', false);
        write("const ".concat(constValue, " = ").concat(options.assignmentVariable, ";\n"));
        write("if(".concat(constValue, ") {\n"), function () {
            write('serializer.writeUInt8(1);\n');
            append(_this.getContainerDeclarationGenerator().createParamEncodingStatement((0, tslib_1.__assign)((0, tslib_1.__assign)({}, paramType), { type: constants_1.Syntax.ContainerParam, paramType: paramType.arguments[0] }), {
                assignmentVariable: constValue
            }));
        }, "}\n");
        write('else \n');
        write('{\n', function () {
            write('serializer.writeUInt8(0);\n');
        }, '}\n');
        return valueOf();
    };
    OptionalCodeGenerator.prototype.getDefaultValueExpression = function () {
        return 'undefined';
    };
    return OptionalCodeGenerator;
}(template_code_generator_1["default"]));
exports["default"] = OptionalCodeGenerator;
