"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var template_code_generator_1 = (0, tslib_1.__importDefault)(require("./template-code-generator"));
var TypedArrayCodeGenerator = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(TypedArrayCodeGenerator, _super);
    function TypedArrayCodeGenerator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TypedArrayCodeGenerator.prototype.getDecodingCode = function (_, options) {
        var _a = this.cs, valueOf = _a.valueOf, write = _a.write;
        write("".concat(options.assignmentVariable, " = deserializer.readBuffer(deserializer.readUInt32());\n"));
        return valueOf();
    };
    TypedArrayCodeGenerator.prototype.getEncodingCode = function (_, _a) {
        var assignmentVariable = _a.assignmentVariable;
        var _b = this.cs, valueOf = _b.valueOf, write = _b.write;
        var byteArrayVariable = this.getVariableName(assignmentVariable);
        write("const ".concat(byteArrayVariable, " = ").concat(assignmentVariable, ";\n"));
        write("serializer.writeUInt32(".concat(byteArrayVariable, ".length);\n"));
        write("serializer.writeBuffer(".concat(byteArrayVariable, ");\n"));
        return valueOf();
    };
    TypedArrayCodeGenerator.prototype.getDefaultValueExpression = function () {
        return '';
    };
    return TypedArrayCodeGenerator;
}(template_code_generator_1["default"]));
exports["default"] = TypedArrayCodeGenerator;
