"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var code_generator_child_1 = (0, tslib_1.__importDefault)(require("./code-generator-child"));
var UtilClassCodeGenerator = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(UtilClassCodeGenerator, _super);
    function UtilClassCodeGenerator() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UtilClassCodeGenerator.prototype.generate = function () {
        var _this = this;
        var _a = this.cs, write = _a.write, valueOf = _a.valueOf;
        write('export class Util {\n', function () {
            write('public decode(deserializer: Deserializer): DataContainer {\n', function () {
                var e_1, _a;
                write('const id = deserializer.readUInt32();\n');
                var _loop_1 = function (container) {
                    var name = _this.getPrefixPackage().concat(container.name.split('.'));
                    name[name.length - 1] = _this.getInterfaceName(name[name.length - 1]);
                    write("if(id === 0x".concat(container.id.toString(16), ") {\n"), function () {
                        write("return ".concat(name.join('.'), ".decode(deserializer, true);\n"));
                    }, '}\n');
                };
                try {
                    for (var _b = (0, tslib_1.__values)(_this.getContainers()), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var container = _c.value;
                        _loop_1(container);
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b["return"])) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
                write('throw new Error(`No container found with id ${id}`);\n');
            }, '}\n');
        }, '}\n');
        return valueOf();
    };
    return UtilClassCodeGenerator;
}(code_generator_child_1["default"]));
exports["default"] = UtilClassCodeGenerator;
