"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var template_processor_1 = (0, tslib_1.__importDefault)(require("./template-processor"));
var param_1 = require("../ast-parser/param");
var MapProcessor = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(MapProcessor, _super);
    function MapProcessor() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MapProcessor.prototype.encode = function (serializer, args, value) {
        var e_1, _a;
        serializer.writeUInt32(value.size);
        var _b = (0, tslib_1.__read)(args, 2), keyParam = _b[0], valueParam = _b[1];
        if (keyParam.type !== param_1.Params.Generic) {
            throw MapProcessor.errors.keyMustBeGeneric;
        }
        try {
            for (var _c = (0, tslib_1.__values)(value.keys()), _d = _c.next(); !_d.done; _d = _c.next()) {
                var key = _d.value;
                this.schema.encodeGeneric(serializer, keyParam.name, key);
                this.schema.encodeContainerParam(serializer, valueParam, value.get(key));
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_d && !_d.done && (_a = _c["return"])) _a.call(_c);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    MapProcessor.prototype.decode = function (deserializer, args, result, prop) {
        var length = deserializer.readUInt32();
        var _a = (0, tslib_1.__read)(args, 2), key = _a[0], value = _a[1];
        if (key.type !== param_1.Params.Generic) {
            throw MapProcessor.errors.keyMustBeGeneric;
        }
        var map = new Map();
        for (var i = 0; i < length; i++) {
            var data = {};
            var keyValue = this.schema.decodeGeneric(deserializer, key.name);
            this.schema.decodeContainerParam(deserializer, value, data, 'result');
            map.set(keyValue, data.result);
        }
        result[prop] = map;
    };
    MapProcessor.errors = {
        keyMustBeGeneric: new Error('Key argument must be generic')
    };
    return MapProcessor;
}(template_processor_1["default"]));
exports["default"] = MapProcessor;
