"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var template_processor_1 = (0, tslib_1.__importDefault)(require("./template-processor"));
var OptionalProcessor = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(OptionalProcessor, _super);
    function OptionalProcessor() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    OptionalProcessor.prototype.encode = function (serializer, args, value) {
        if (value != undefined && value != null) {
            serializer.writeBoolean(true);
            this.schema.encodeContainerParam(serializer, args[0], value);
            return;
        }
        serializer.writeBoolean(false);
    };
    OptionalProcessor.prototype.decode = function (deserializer, args, result, prop) {
        if (!deserializer.readBoolean())
            return;
        this.schema.decodeContainerParam(deserializer, args[0], result, prop);
    };
    return OptionalProcessor;
}(template_processor_1["default"]));
exports["default"] = OptionalProcessor;
