/// <reference types="node" />
import Long from 'long';
export default class Serializer {
    private length;
    private buffer;
    private view;
    private offset;
    private memoryGrowthAmount;
    constructor(length?: number);
    reset(): void;
    getBuffer(): Buffer;
    allocate(length: number): void;
    writeBuffer(source: Buffer): void;
    writeBoolean(n: boolean): void;
    writeInt8(n: number): void;
    writeUInt8(n: number): void;
    writeUInt16(n: number): void;
    writeInt16(n: number): void;
    writeUInt32(n: number): void;
    writeInt32(n: number): void;
    writeUInt64(n: Long | number): void;
    writeInt64(n: Long | number): void;
    writeDouble(n: number): void;
    writeFloat(n: number): void;
    writeString(n: string): void;
    private writeLong;
}
