import Serializer from './serializer';
import Deserializer from './deserializer';
import Schema from './schema';
import { Param } from '../ast-parser/param';
export declare type PropertyType = string | number;
export default abstract class TemplateProcessor<Argument = Param, Input extends any = any> {
    schema: Schema;
    constructor(schema: Schema);
    abstract encode(serializer: Serializer, args: Argument[], value: Input): void;
    abstract decode(deserializer: Deserializer, input: Argument[], result: any, prop: any): void;
}
