"use strict";
exports.__esModule = true;
var tslib_1 = require("tslib");
var template_processor_1 = (0, tslib_1.__importDefault)(require("./template-processor"));
var VectorProcessor = /** @class */ (function (_super) {
    (0, tslib_1.__extends)(VectorProcessor, _super);
    function VectorProcessor() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    VectorProcessor.prototype.decode = function (deserializer, args, result, prop) {
        var length = deserializer.readUInt32();
        var array = new Array(length);
        var arrayOf = args[0];
        for (var i = 0; i < length; i++)
            this.schema.decodeContainerParam(deserializer, arrayOf, array, i);
        result[prop] = array;
    };
    VectorProcessor.prototype.encode = function (serializer, args, input) {
        var arrayOf = args[0];
        if (!Array.isArray(input))
            throw new Error("\"Vector\" param value must be an array");
        var ii = input.length;
        serializer.writeUInt32(ii);
        for (var i = 0; i < ii; i++)
            this.schema.encodeContainerParam(serializer, arrayOf, input[i]);
    };
    return VectorProcessor;
}(template_processor_1["default"]));
exports["default"] = VectorProcessor;
